Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_AlgorithmSmall.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_AlgorithmSmall.cshtml	(revision 13696)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_AlgorithmSmall.cshtml	(revision 13696)
@@ -0,0 +1,57 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.Models.AlgorithmContainer
+@{int randomal = Model.randy.Next(2000); }
+<p class="text-center">
+    <a class="btn btn-primary" 
+       data-toggle="collapse" 
+       href="#collapseExample@(randomal)"  
+       aria-expanded="false" 
+       aria-controls="collapseExample@(randomal)">
+        @Model.algo.Name
+    </a>
+
+</p>
+<div class="collapse" id="collapseExample@(randomal)" style="margin-left:10px;margin-right:10px">
+    <div class="panel panel-primary">
+        <div class="panel-heading panel-primary text-center" >
+            <p>@Model.algo.Description</p>
+        </div>
+        <table class="table table-responsive card-block" style="table-layout:fixed;overflow-wrap:break-word">
+            <thead>
+                <tr>
+                    <th>Parameter</th>
+                    <th>Value</th>
+                </tr>
+            </thead>
+            <tbody>
+                @foreach (var prob in Model.algo.Problem.Parameters.OrderBy(x => x.Name))
+                {
+                    <tr>
+                        <td >@prob.Name</td>
+
+                        <td >@prob.ActualValue</td>
+                    </tr>
+
+                }
+            </tbody>
+        </table>
+        <table class="table table-condensed" style="table-layout:fixed;overflow-wrap:break-word">
+            <thead>
+                <tr>
+                    <th>Parameter</th>
+                    <th>Value</th>
+                </tr>
+            </thead>
+            <tbody>
+                @foreach (var par in Model.algo.Parameters.OrderBy(x => x.Name))
+                {
+                    <tr>
+                        <td>@par.Name</td>
+
+                        <td>@par.ActualValue</td>
+                    </tr>
+
+                }
+            </tbody>
+        </table>
+    </div>
+</div>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRun.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRun.cshtml	(revision 13689)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRun.cshtml	(revision 13696)
@@ -1,4 +1,5 @@
 ﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.FileOpeningViewModel
-
+@{System.Random randomizer = new Random();
+    int randy = randomizer.Next(2000); }
 <div style="margin-left:20px;margin-right:20px">
     <div class="row" style="text-align:center">
@@ -8,5 +9,5 @@
         <h1 data-toggle="tooltip" title="@Model.SelectedTask.ItemTask.ItemName
             @Model.SelectedTask.ItemTask.Description ">
-            <span class="label label-primary">Batch Run: @Model.SelectedTask.ItemTask.Name</span>
+            <span class="label label-warning ">Batch: @Model.SelectedBatchRun.Name</span>
         </h1>
         <a class="btn btn-success" id="fakehiveadd" onclick="addtoHive()">Add to Hive</a>
@@ -22,51 +23,48 @@
         </div>
     </div>
+    <h4>
+        Repeats: @Model.SelectedBatchRun.Repetitions x
+        <label>
+            <input type="checkbox" checked data-toggle="toggle" data-onstyle="warning"
+                   onchange="toggleChild([], @randy)" />
+            Distribute child tasks
+        </label>
+    </h4>
+    <div id="childs@(randy)">
+        @for (var k = 0; k < Model.SelectedBatchRun.Repetitions; k++)
+        {
+            @if (Model.SelectedBatchRun.Optimizer is HeuristicLab.Optimization.IAlgorithm)
+            {
+                @Html.Partial("OpenFilePartials/_AlgorithmSmall",
+                new HeuristicLab.Clients.Hive.WebJobManager.Models.AlgorithmContainer(
+                    ((HeuristicLab.Optimization.IAlgorithm)Model.SelectedBatchRun.Optimizer),
+                    randomizer));
+
+            }
+            else if (Model.SelectedBatchRun.Optimizer is HeuristicLab.Optimization.BatchRun)
+            {
+                @Html.Partial("OpenFilePartials/_BatchRunSmall",
+                new HeuristicLab.Clients.Hive.WebJobManager.Models.BatchRunContainer(
+                    ((HeuristicLab.Optimization.BatchRun)Model.SelectedBatchRun.Optimizer),
+                    new List<int[]>(),
+                    new int[] { 0, k },
+                    randomizer));
+
+            }
+            else if (Model.SelectedBatchRun.Optimizer is HeuristicLab.Optimization.Experiment)
+            {
+                @Html.Partial("OpenFilePartials/_ExperimentSmall",
+                new HeuristicLab.Clients.Hive.WebJobManager.Models.ExperimentContainer(
+                    ((HeuristicLab.Optimization.Experiment)Model.SelectedBatchRun.Optimizer),
+                    new List<int[]>(),
+                    new int[] { 0, k },
+                    randomizer));
+
+            }
+        }
+    </div>
 
     <script type="text/javascript">
-        function addtoHive() {
-            document.getElementById("fakehiveadd").style.display = "none";
-            document.getElementById("progdiv").style.display = "";
-            document.getElementById("result").style.display = "";
-            document.getElementById("realhiveadd").click();
 
-        }
-        function setProb() {
-            resetAll();
-            document.getElementById("problem").style.display = "";
-            document.getElementById("btnprob").className += " active";
-
-        }
-        function setAlgo() {
-            resetAll();
-            document.getElementById("algorithm").style.display = "";
-            document.getElementById("btnalg").className += " active";
-        }
-        function setResults() {
-            resetAll();
-            document.getElementById("results").style.display = "";
-            document.getElementById("btnresults").className += " active";
-        }
-        function setRuns() {
-            resetAll();
-            document.getElementById("runs").style.display = "";
-            document.getElementById("btnruns").className += " active";
-        }
-        function setEngine() {
-            resetAll();
-            document.getElementById("engine").style.display = "";
-            document.getElementById("btnengine").className += " active";
-        }
-        function resetAll() {
-            document.getElementById("problem").style.display = "none";
-            document.getElementById("algorithm").style.display = "none";
-            document.getElementById("results").style.display = "none";
-            document.getElementById("runs").style.display = "none";
-            document.getElementById("engine").style.display = "none";
-            document.getElementById("btnprob").className = document.getElementById("btnprob").className.replace(/(?:^|\s)active(?!\S)/g, '');
-            document.getElementById("btnalg").className = document.getElementById("btnalg").className.replace(/(?:^|\s)active(?!\S)/g, '');
-            document.getElementById("btnresults").className = document.getElementById("btnresults").className.replace(/(?:^|\s)active(?!\S)/g, '');
-            document.getElementById("btnruns").className = document.getElementById("btnruns").className.replace(/(?:^|\s)active(?!\S)/g, '');
-            document.getElementById("btnengine").className = document.getElementById("btnengine").className.replace(/(?:^|\s)active(?!\S)/g, '');
-        }
         $(document).ready(function () {
             $('[data-toggle="tooltip"]').tooltip();
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRunSmall.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRunSmall.cshtml	(revision 13696)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_BatchRunSmall.cshtml	(revision 13696)
@@ -0,0 +1,69 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.Models.BatchRunContainer
+@{
+    int randombr = Model.randy.Next(2000); }
+<p class="text-center">
+    <a class="btn btn-warning"
+       data-toggle="collapse"
+       href="#collapseExample@(randombr)"
+       aria-expanded="false"
+       aria-controls="collapseExample@(randombr)">
+        @Model.batch.Name
+    </a>
+
+</p>
+<div class="collapse" id="collapseExample@(randombr)" style="margin-left:10px;margin-right:10px">
+    <div class="panel panel-warning">
+        <div class="panel-heading panel-warning text-center">
+            <p>
+                Repeats @Model.batch.Repetitions X
+            </p>
+            <p>
+                <label>
+                    @{ var builder = "[";
+                        foreach (var arr in Model.depth)
+                        {
+                            builder += "[" + String.Join(",", arr) + "],";
+                        }
+                        builder += "]";
+                    }
+                    <input type="checkbox" checked data-toggle="toggle" data-onstyle="warning"
+                           onchange="toggleChild(@builder, @randombr)" />
+                    Distribute child tasks
+                </label>
+            </p>
+        </div>
+        <div id="childs@(randombr)">
+            @for (var k = 0; k < Model.batch.Repetitions; k++)
+            {
+                @if (Model.batch.Optimizer is HeuristicLab.Optimization.IAlgorithm)
+                {
+                    @Html.Partial("OpenFilePartials/_AlgorithmSmall",
+                    new HeuristicLab.Clients.Hive.WebJobManager.Models.AlgorithmContainer(
+                        ((HeuristicLab.Optimization.IAlgorithm)Model.batch.Optimizer),
+                        Model.randy))
+
+                }
+                else if (Model.batch.Optimizer is HeuristicLab.Optimization.BatchRun)
+                {
+                    @Html.Partial("OpenFilePartials/_BatchRunSmall",
+                    new HeuristicLab.Clients.Hive.WebJobManager.Models.BatchRunContainer(
+                        ((HeuristicLab.Optimization.BatchRun)Model.batch.Optimizer),
+                        Model.depth.ToList(),
+                        new int[] { 0, k },
+                        Model.randy)) ;
+
+                }
+                else if (Model.batch.Optimizer is HeuristicLab.Optimization.Experiment)
+                {
+                    @Html.Partial("OpenFilePartials/_ExperimentSmall",
+                    new HeuristicLab.Clients.Hive.WebJobManager.Models.ExperimentContainer(
+                        ((HeuristicLab.Optimization.Experiment)Model.batch.Optimizer),
+                        Model.depth.ToList(),
+                        new int[] { 0, k },
+                        Model.randy)) ;
+
+                }
+            }
+        </div>
+    </div>
+</div>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_Experiment.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_Experiment.cshtml	(revision 13689)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_Experiment.cshtml	(revision 13696)
@@ -1,4 +1,4 @@
 ﻿@model HeuristicLab.Clients.Hive.WebJobManager.ViewModels.FileOpeningViewModel
-
+@{System.Random randomizer = new Random(); }
 <div style="margin-left:20px;margin-right:20px">
     <div class="row" style="text-align:center">
@@ -8,5 +8,5 @@
         <h1 data-toggle="tooltip" title=" @Model.SelectedTask.ItemTask.ItemName
             @Model.SelectedTask.ItemTask.Description ">
-            <span class="label label-primary">Experiment: @Model.SelectedTask.ItemTask.Name</span>
+            <span class="label label-danger">Experiment: @Model.SelectedTask.ItemTask.Name</span>
         </h1>
         <a class="btn btn-success" id="fakehiveadd" onclick="addtoHive()">Add to Hive</a>
@@ -18,49 +18,46 @@
                  id="progress"
                  aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width:10%">
-                
+
             </div>
         </div>
     </div>
+    <h4>
+        Children: @Model.SelectedExperiment.Optimizers.Count
+    </h4>
+    @for (var i = 0; i < Model.SelectedExperiment.Optimizers.Count; i++)
+    {
+        @if (Model.SelectedExperiment.Optimizers[i] is HeuristicLab.Optimization.IAlgorithm)
+        {
+            @Html.Partial("OpenFilePartials/_AlgorithmSmall",
+new HeuristicLab.Clients.Hive.WebJobManager.Models.AlgorithmContainer(
+ ((HeuristicLab.Optimization.IAlgorithm)Model.SelectedExperiment.Optimizers[i]),
+ randomizer));
+
+        }
+        else if (Model.SelectedExperiment.Optimizers[i] is HeuristicLab.Optimization.BatchRun)
+        {
+            @Html.Partial("OpenFilePartials/_BatchRunSmall",
+new HeuristicLab.Clients.Hive.WebJobManager.Models.BatchRunContainer(
+    ((HeuristicLab.Optimization.BatchRun)Model.SelectedExperiment.Optimizers[i]),
+    new List<int[]>(),
+    new int[] { i, 0 },
+    randomizer)) ;
+
+        }
+        else if (Model.SelectedExperiment.Optimizers[i] is HeuristicLab.Optimization.Experiment)
+        {
+            @Html.Partial("OpenFilePartials/_ExperimentSmall",
+new HeuristicLab.Clients.Hive.WebJobManager.Models.ExperimentContainer(
+    ((HeuristicLab.Optimization.Experiment)Model.SelectedExperiment.Optimizers[i]),
+    new List<int[]>(),
+    new int[] { i, 0 },
+           randomizer)) ;
+
+        }
+
+    }
 
     <script type="text/javascript">
-        
-        function setProb() {
-            resetAll();
-            document.getElementById("problem").style.display = "";
-            document.getElementById("btnprob").className += " active";
 
-        }
-        function setAlgo() {
-            resetAll();
-            document.getElementById("algorithm").style.display = "";
-            document.getElementById("btnalg").className += " active";
-        }
-        function setResults() {
-            resetAll();
-            document.getElementById("results").style.display = "";
-            document.getElementById("btnresults").className += " active";
-        }
-        function setRuns() {
-            resetAll();
-            document.getElementById("runs").style.display = "";
-            document.getElementById("btnruns").className += " active";
-        }
-        function setEngine() {
-            resetAll();
-            document.getElementById("engine").style.display = "";
-            document.getElementById("btnengine").className += " active";
-        }
-        function resetAll() {
-            document.getElementById("problem").style.display = "none";
-            document.getElementById("algorithm").style.display = "none";
-            document.getElementById("results").style.display = "none";
-            document.getElementById("runs").style.display = "none";
-            document.getElementById("engine").style.display = "none";
-            document.getElementById("btnprob").className = document.getElementById("btnprob").className.replace(/(?:^|\s)active(?!\S)/g, '');
-            document.getElementById("btnalg").className = document.getElementById("btnalg").className.replace(/(?:^|\s)active(?!\S)/g, '');
-            document.getElementById("btnresults").className = document.getElementById("btnresults").className.replace(/(?:^|\s)active(?!\S)/g, '');
-            document.getElementById("btnruns").className = document.getElementById("btnruns").className.replace(/(?:^|\s)active(?!\S)/g, '');
-            document.getElementById("btnengine").className = document.getElementById("btnengine").className.replace(/(?:^|\s)active(?!\S)/g, '');
-        }
         $(document).ready(function () {
             $('[data-toggle="tooltip"]').tooltip();
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_ExperimentSmall.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_ExperimentSmall.cshtml	(revision 13696)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Job/OpenFilePartials/_ExperimentSmall.cshtml	(revision 13696)
@@ -0,0 +1,50 @@
+﻿@model HeuristicLab.Clients.Hive.WebJobManager.Models.ExperimentContainer
+@{int randombr = Model.randy.Next(2000); }
+<p class="text-center">
+    <a class="btn btn-danger"
+       data-toggle="collapse"
+       href="#collapseExample@(randombr)"
+       aria-expanded="false"
+       aria-controls="collapseExample@(randombr)">
+        @Model.exp.Name
+    </a>
+
+</p>
+<div class="collapse" id="collapseExample@(randombr)" style="margin-left:10px;margin-right:10px">
+    <div class="panel panel-danger">
+        <div class="panel-heading panel-danger text-center">
+            <p>Children: @Model.exp.Optimizers.Count</p>
+        </div>
+        @for (var j = 0; j < Model.exp.Optimizers.Count; j++)
+        {
+            @if (Model.exp.Optimizers[j] is HeuristicLab.Optimization.IAlgorithm)
+            {
+                @Html.Partial("OpenFilePartials/_AlgorithmSmall",
+                    new HeuristicLab.Clients.Hive.WebJobManager.Models.AlgorithmContainer(
+                 ((HeuristicLab.Optimization.IAlgorithm)Model.exp.Optimizers[j]),
+                 Model.randy))
+
+            }
+            else if (Model.exp.Optimizers[j] is HeuristicLab.Optimization.BatchRun)
+            {
+                @Html.Partial("OpenFilePartials/_BatchRunSmall",
+                new HeuristicLab.Clients.Hive.WebJobManager.Models.BatchRunContainer(
+                    ((HeuristicLab.Optimization.BatchRun)Model.exp.Optimizers[j]),
+                    Model.depth.ToList(),
+                    new int[] { j, 0 },
+                    Model.randy)) ;
+
+            }
+            else if (Model.exp.Optimizers[j] is HeuristicLab.Optimization.Experiment)
+            {
+                @Html.Partial("OpenFilePartials/_ExperimentSmall",
+                new HeuristicLab.Clients.Hive.WebJobManager.Models.ExperimentContainer(
+                    ((HeuristicLab.Optimization.Experiment)Model.exp.Optimizers[j]),
+                    Model.depth.ToList(),
+                    new int[] { j, 0 },
+                    Model.randy)) ;
+
+            }
+        }
+    </div>
+</div>
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Shared/_Layout.cshtml
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Shared/_Layout.cshtml	(revision 13689)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Views/Shared/_Layout.cshtml	(revision 13696)
@@ -11,4 +11,6 @@
         <link href="~/css/min/site.min.css" rel="stylesheet" />
     </environment>
+    <link href="https://gitcdn.github.io/bootstrap-toggle/2.2.0/css/bootstrap-toggle.min.css" rel="stylesheet">
+    
 </head>
 <body>
@@ -23,5 +25,5 @@
         <script src="~/js/jquery-2.1.1.js"></script>
         <script src="~/js/bootstrap.js"></script>
-      
+        <script src="https://gitcdn.github.io/bootstrap-toggle/2.2.0/js/bootstrap-toggle.min.js"></script>
         <script src="~/js/jquery.signalr-2.1.2.js"></script>
         <script src='~/signalr/js'></script>