Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/MctsSymbolicRegressionTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/MctsSymbolicRegressionTest.cs	(revision 13707)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Algorithms.DataAnalysis-3.4/MctsSymbolicRegressionTest.cs	(revision 13708)
@@ -277,5 +277,5 @@
 
     #region Nguyen
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -285,5 +285,5 @@
       TestMcts(regProblem);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -293,5 +293,5 @@
       TestMcts(regProblem);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -301,5 +301,5 @@
       TestMcts(regProblem, successThreshold: 0.99);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -309,5 +309,5 @@
       TestMcts(regProblem);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -317,5 +317,5 @@
       TestMcts(regProblem);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -325,5 +325,5 @@
       TestMcts(regProblem);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -333,5 +333,5 @@
       TestMcts(regProblem);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -341,5 +341,5 @@
       TestMcts(regProblem, successThreshold: 0.99);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -349,5 +349,5 @@
       TestMcts(regProblem, iterations: 10000);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -357,5 +357,5 @@
       TestMcts(regProblem);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -365,5 +365,5 @@
       TestMcts(regProblem, 10000, 0.95); // cannot solve exactly in 10000 iterations
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -377,5 +377,5 @@
 
     #region keijzer
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "long")]
@@ -388,5 +388,5 @@
     }
 
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -400,10 +400,21 @@
     }
 
+    // [TestMethod]
+    [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
+    public void MctsSymbRegBenchmarkKeijzer7() {
+      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.KeijzerInstanceProvider();
+      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("Keijzer 7 f(")));
+      // some Keijzer problem instances have very large test partitions (here we are not concerened about test performance)
+      if (regProblem.TestPartition.End - regProblem.TestPartition.Start > 1000) regProblem.TestPartition.End = regProblem.TestPartition.Start + 1000;
+      TestMcts(regProblem);
+    }
+
     [TestMethod]
-    [TestCategory("Algorithms.DataAnalysis")]
-    [TestProperty("Time", "short")]
-    public void MctsSymbRegBenchmarkKeijzer7() {
-      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.KeijzerInstanceProvider();
-      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("Keijzer 7 f(")));
+    // [TestCategory("Algorithms.DataAnalysis")]
+    [TestProperty("Time", "short")]
+    public void MctsSymbRegBenchmarkKeijzer8() {
+      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.KeijzerInstanceProvider();
+      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("Keijzer 8 f(")));
       // some Keijzer problem instances have very large test partitions (here we are not concerened about test performance)
       if (regProblem.TestPartition.End - regProblem.TestPartition.Start > 1000) regProblem.TestPartition.End = regProblem.TestPartition.Start + 1000;
@@ -412,16 +423,5 @@
 
     [TestMethod]
-    [TestCategory("Algorithms.DataAnalysis")]
-    [TestProperty("Time", "short")]
-    public void MctsSymbRegBenchmarkKeijzer8() {
-      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.KeijzerInstanceProvider();
-      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("Keijzer 8 f(")));
-      // some Keijzer problem instances have very large test partitions (here we are not concerened about test performance)
-      if (regProblem.TestPartition.End - regProblem.TestPartition.Start > 1000) regProblem.TestPartition.End = regProblem.TestPartition.Start + 1000;
-      TestMcts(regProblem);
-    }
-
-    [TestMethod]
-    [TestCategory("Algorithms.DataAnalysis")]
+    // [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
     public void MctsSymbRegBenchmarkKeijzer9() {
@@ -460,5 +460,5 @@
     }
      */
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -471,5 +471,5 @@
       TestMcts(regProblem, iterations: 10000, allowLog: false, allowExp: false, allowInv: false, successThreshold: 0.99); // cannot solve exactly in 10000 iterations
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]
@@ -481,5 +481,5 @@
       TestMcts(regProblem);
     }
-    [TestMethod]
+    // [TestMethod]
     [TestCategory("Algorithms.DataAnalysis")]
     [TestProperty("Time", "short")]